Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub
    Friend WithEvents dgAddressBook As System.Windows.Forms.DataGrid
    Friend WithEvents MainMenu1 As System.Windows.Forms.MainMenu
    Friend WithEvents mnuFile As System.Windows.Forms.MenuItem
    Friend WithEvents mnuFileOpen As System.Windows.Forms.MenuItem
    Friend WithEvents mnuFileExitSep As System.Windows.Forms.MenuItem
    Friend WithEvents mnuFileExit As System.Windows.Forms.MenuItem
    Friend WithEvents dlgOpenFile As System.Windows.Forms.OpenFileDialog

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.Container

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.mnuFile = New System.Windows.Forms.MenuItem()
        Me.mnuFileOpen = New System.Windows.Forms.MenuItem()
        Me.mnuFileExitSep = New System.Windows.Forms.MenuItem()
        Me.mnuFileExit = New System.Windows.Forms.MenuItem()
        Me.MainMenu1 = New System.Windows.Forms.MainMenu()
        Me.dgAddressBook = New System.Windows.Forms.DataGrid()
        Me.dlgOpenFile = New System.Windows.Forms.OpenFileDialog()
        CType(Me.dgAddressBook, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        '
        'mnuFile
        '
        Me.mnuFile.Index = 0
        Me.mnuFile.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.mnuFileOpen, Me.mnuFileExitSep, Me.mnuFileExit})
        Me.mnuFile.Text = "&File"
        '
        'mnuFileOpen
        '
        Me.mnuFileOpen.Index = 0
        Me.mnuFileOpen.Shortcut = System.Windows.Forms.Shortcut.CtrlO
        Me.mnuFileOpen.Text = "&Open..."
        '
        'mnuFileExitSep
        '
        Me.mnuFileExitSep.Index = 1
        Me.mnuFileExitSep.Text = "-"
        '
        'mnuFileExit
        '
        Me.mnuFileExit.Index = 2
        Me.mnuFileExit.Text = "E&xit"
        '
        'MainMenu1
        '
        Me.MainMenu1.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.mnuFile})
        '
        'dgAddressBook
        '
        Me.dgAddressBook.DataMember = ""
        Me.dgAddressBook.Dock = System.Windows.Forms.DockStyle.Fill
        Me.dgAddressBook.Name = "dgAddressBook"
        Me.dgAddressBook.Size = New System.Drawing.Size(432, 149)
        Me.dgAddressBook.TabIndex = 0
        '
        'dlgOpenFile
        '
        Me.dlgOpenFile.Filter = "XML Files (*.xml)|*.xml|All Files (*.*)|*.*"
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(432, 149)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.dgAddressBook})
        Me.Menu = Me.MainMenu1
        Me.Name = "Form1"
        Me.Text = "ReadXml []"
        CType(Me.dgAddressBook, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)

    End Sub

#End Region

    ' Set the initial dialog directory.
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim path_name As String = Application.StartupPath

        dlgOpenFile.InitialDirectory = path_name.Substring(0, path_name.LastIndexOf("\"))
    End Sub

    Private Sub mnuFileExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileExit.Click
        Me.Close()
    End Sub

    ' Load an XML file.
    Private Sub mnuFileOpen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileOpen.Click
        ' Let the user select the file.
        If dlgOpenFile.ShowDialog() = DialogResult.OK Then
            Dim data_set As New DataSet()

            Try
                ' Read the XML data.
                dgAddressBook.DataSource = Nothing
                data_set.ReadXml(dlgOpenFile.FileName)

                ' Bind the DataGrid to the DataSet.
                dgAddressBook.DataSource = data_set

                ' Display the file name in the form's caption.
                Me.Text = "ReadXml [" & dlgOpenFile.FileName & "]"

                ' Display the DataSet's structure.
                DisplayDataSetStructure(data_set)
            Catch exc As Exception
                MsgBox(exc.Message)
                Me.Text = "ReadXml []"
            End Try
        End If
    End Sub

    ' Display the DataSet's structure.
    Private Sub DisplayDataSetStructure(ByVal data_set As DataSet)
        Dim data_table As DataTable
        Dim data_column As DataColumn
        Dim data_relation As DataRelation

        ' Tell how many tables.
        Debug.WriteLine(data_set.Tables.Count & " tables")

        ' Display the tables.
        For Each data_table In data_set.Tables
            ' Display the table's name.
            Debug.WriteLine("******************************")
            Debug.WriteLine("Table " & data_table.TableName)

            ' Display the table's columns.
            For Each data_column In data_table.Columns
                Debug.WriteLine("Column " & data_column.ColumnName & _
                    " (" & data_column.DataType.ToString & ")")
            Next data_column

            ' Display the table's child relations.
            For Each data_relation In data_table.ChildRelations
                DisplayDataRelation("Child relation: ", data_relation)
            Next data_relation

            ' Display the table's parent relations.
            For Each data_relation In data_table.ParentRelations
                DisplayDataRelation("Parent relation: ", data_relation)
            Next data_relation
        Next data_table
    End Sub

    ' Display information about this DataRelation.
    Private Sub DisplayDataRelation(ByVal relation_name As String, ByVal data_relation As DataRelation)
        Dim parent_columns() As DataColumn
        Dim child_columns() As DataColumn
        Dim i As Integer

        parent_columns = data_relation.ParentColumns
        child_columns = data_relation.ChildColumns
        For i = 0 To parent_columns.GetUpperBound(0)
            Debug.WriteLine(relation_name & _
                parent_columns(i).Table.TableName & "." & _
                parent_columns(i).ColumnName & " = " & _
                child_columns(i).Table.TableName & "." & _
                child_columns(i).ColumnName)
        Next i
    End Sub
End Class
