# Create the accounts database tables.

# Create the database.
# Comment this statement out if the database already exists
# or if you are using an Access database.
CREATE DATABASE TestAccounts
ON
  (NAME = ts_data,
   FILENAME = 'C:\Temp\TestAccounts.mdf',
   SIZE = 2MB,
   MAXSIZE = 10MB,
   FILEGROWTH = 2MB
)
LOG ON
  (NAME = ts_log,
   FILENAME = 'C:\Temp\TestAccounts.ldf',
   SIZE = 1MB,
   MAXSIZE = 5MB,
   FILEGROWTH = 1MB
);

# Use the new database.
# Comment this statement out if you are using an Access database.
USE TestAccounts;

# CompanyAccounts.
CREATE TABLE CompanyAccounts (
    CompanyName     VARCHAR(60)   PRIMARY KEY,
    FEIN            CHAR(9)       NOT NULL,
    AccountBalance  MONEY         NOT NULL
);

# IndividualAccounts.
CREATE TABLE IndividualAccounts (
    FirstName       VARCHAR(40)   NOT NULL,
    LastName        VARCHAR(40)   NOT NULL,
    SSN             CHAR(9)       NOT NULL,
    AccountBalance  MONEY         NOT NULL
);
